library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity miner_tb is
end miner_tb;

architecture arch of miner_tb is
  
   signal osc_clk          : std_logic := '0';
   signal midstate_vw_in   : std_logic_vector(255 downto 0) := x"2b3f81261b3cfd001db436cfd4c8f3f9c7450c9a0d049bee71cba0ea2619c0b5";
   signal data2_vw_in      : std_logic_vector(255 downto 0) := x"000000000000000000000000800000000000000039f3001b6b7b8d4dc14bfc31";
   
   --signal midstate_vw_in   : std_logic_vector(255 downto 0) := (others => '0');
   --signal data2_vw_in      : std_logic_vector(255 downto 0) := (others => '0');
   
   signal golden_nonce_out : std_logic_vector(31 downto 0);
   
  
begin

   osc_clk <= not osc_clk after 6 ns;
   
   dut : entity work.miner_top
   port map 
   (
      osc_clk          => osc_clk,         
      midstate_vw_in   => midstate_vw_in,  
      data2_vw_in      => data2_vw_in,     
      golden_nonce_out => golden_nonce_out
   );

  
end architecture;