library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity sum0 is
   port 
   (
      x : in  std_logic_vector(31 downto 0);
      y : out std_logic_vector(31 downto 0)
   );
end sum0;

architecture arch of sum0 is
   
begin

   y <= (x(1 downto 0) & x(31 downto 2)) xor (x(12 downto 0) & x(31 downto 13)) xor (x(21 downto 0) & x(31 downto 22));
  
end architecture;

----------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity sum1 is
   port 
   (
      x : in  std_logic_vector(31 downto 0);
      y : out std_logic_vector(31 downto 0)
   );
end sum1;

architecture arch of sum1 is
   
begin

   y <= (x(5 downto 0) & x(31 downto 6)) xor (x(10 downto 0) & x(31 downto 11)) xor (x(24 downto 0) & x(31 downto 25));
  
end architecture;


----------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity ch is
   port 
   (
      x : in  std_logic_vector(31 downto 0);
      y : in  std_logic_vector(31 downto 0);
      z : in  std_logic_vector(31 downto 0);
      o : out std_logic_vector(31 downto 0)
   );
end ch;

architecture arch of ch is
   
begin

   o <= z xor (x and (y xor z));
  
end architecture;


----------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity maj is
   port 
   (
      x : in  std_logic_vector(31 downto 0);
      y : in  std_logic_vector(31 downto 0);
      z : in  std_logic_vector(31 downto 0);
      o : out std_logic_vector(31 downto 0)
   );
end maj;

architecture arch of maj is
   
begin

   o <= (x and y) or (z and (x or y));
  
end architecture;



----------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity sigma0 is
   port 
   (
      x : in  std_logic_vector(31 downto 0);
      y : out std_logic_vector(31 downto 0)
   );
end sigma0;

architecture arch of sigma0 is
   
begin

   y(31 downto 29) <= x(6 downto 4) xor x(17 downto 15);
   y(28 downto 0) <= (x(3 downto 0) & x(31 downto 7)) xor (x(14 downto 0) & x(31 downto 18)) xor x(31 downto 3);
  
end architecture;


----------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity sigma1 is
   port 
   (
      x : in  std_logic_vector(31 downto 0);
      y : out std_logic_vector(31 downto 0)
   );
end sigma1;

architecture arch of sigma1 is
   
begin

   y(31 downto 22) <= x(16 downto 7) xor x(18 downto 9);
   y(21 downto 0) <= (x(6 downto 0) & x(31 downto 17)) xor (x(8 downto 0) & x(31 downto 19)) xor x(31 downto 10);
  
end architecture;




